//
//              VPIFACE.H
//              =========
//
// The DLL-Interface for the "Virtual Print Engine Community- / Standard Edition" and above.
//
// To be used by the calling applications.
//
// Copyright  1993 - 2008 IDEAL Software GmbH, Neuss, Germany. All rights reserved.
//


#ifndef _MODULE_VPIFACE
#define _MODULE_VPIFACE


#ifdef _INC_WINDOWS		//defined in windows.h

	// Windows platforms
	#define EXPO	WINAPI

#else

	// Non-Windows platforms
	#define EXPO
	typedef void*	HWND;

#endif


// Prototype for optional Message Callback (see function VpeSetMsgCallback()):
typedef LRESULT (EXPO *VPE_MSG_CALLBACK)(UINT Msg, WPARAM wParam, LPARAM lParam);


// Type of VPE coordinates
typedef double VpeCoord;

// Type of VPE Handles
typedef void * VpeHandle;


#ifndef VPE_ACTIVEX
#ifdef __cplusplus
extern "C"
{
#endif

//{{DLLIMPORT("vpei3240.dll")

   void EXPO VpeLicense(VpeHandle hDoc, LPCTSTR serial1, LPCTSTR serial2);
   int  EXPO VpeGetVersion();
   int  EXPO VpeGetReleaseNumber();
   int  EXPO VpeGetBuildNumber();
   int  EXPO VpeGetEdition();

   VpeHandle EXPO VpeOpenDoc(HWND hWndParent, LPCTSTR title, long flags);
   VpeHandle EXPO VpeOpenDocFile(HWND hWndParent, LPCTSTR file_name, LPCTSTR title, long flags);
   int  EXPO VpeCloseDoc(VpeHandle hDoc);

   void EXPO VpeSetPageFormat(VpeHandle hDoc, int page_dimension);
   void EXPO VpeSetPageWidth(VpeHandle hDoc, VpeCoord page_width);
   void EXPO VpeSetPageHeight(VpeHandle hDoc, VpeCoord page_height);
   VpeCoord EXPO VpeGetPageWidth(VpeHandle hDoc);
   VpeCoord EXPO VpeGetPageHeight(VpeHandle hDoc);
   void EXPO VpeSetPageOrientation(VpeHandle hDoc, int orientation);
   int  EXPO VpeGetPageOrientation(VpeHandle hDoc);
   void EXPO VpeSetPaperBin(VpeHandle hDoc, int bin);
   int  EXPO VpeGetPaperBin(VpeHandle hDoc);
   void EXPO VpeSetDefOutRect(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2);
   void EXPO VpeSetOutRect(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2);
   VpeCoord EXPO VpeGet(VpeHandle hDoc, VpeCoord what);
   void EXPO VpeSet(VpeHandle hDoc, VpeCoord what, VpeCoord value);
   void EXPO VpeStorePos(VpeHandle hDoc);
   void EXPO VpeRestorePos(VpeHandle hDoc);

   void EXPO VpeSetPen(VpeHandle hDoc, VpeCoord pen_size, int pen_style, COLORREF color);
   void EXPO VpeSetPenSize(VpeHandle hDoc, VpeCoord pen_size);
   VpeCoord EXPO VpeGetPenSize(VpeHandle hDoc);
   void EXPO VpePenSize(VpeHandle hDoc, VpeCoord pen_size);
   void EXPO VpeSetPenStyle(VpeHandle hDoc, int pen_style);
   void EXPO VpePenStyle(VpeHandle hDoc, int pen_style);
   void EXPO VpeSetPenColor(VpeHandle hDoc, COLORREF color);
   void EXPO VpePenColor(VpeHandle hDoc, COLORREF color);
   void EXPO VpeNoPen(VpeHandle hDoc);
   void EXPO VpeLine(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2);
   VpeHandle EXPO VpePolyLine(VpeHandle hDoc, unsigned int size);
   void EXPO VpeAddPolyPoint(VpeHandle hDoc, VpeHandle p,  VpeCoord x, VpeCoord y);
   VpeHandle EXPO VpePolygon(VpeHandle hDoc, unsigned int size);
   void EXPO VpeAddPolygonPoint(VpeHandle hDoc, VpeHandle p, VpeCoord x, VpeCoord y);
   void EXPO VpeSetBkgColor(VpeHandle hDoc, COLORREF color);
   void EXPO VpeSetBkgGradientStartColor(VpeHandle hDoc, COLORREF color_start);
   void EXPO VpeSetBkgGradientEndColor(VpeHandle hDoc, COLORREF color_end);
   void EXPO VpeSetBkgGradientRotation(VpeHandle hDoc, int angle);
   void EXPO VpeSetBkgGradientPrint(VpeHandle hDoc, int mode);
   void EXPO VpeSetBkgGradientPrintSolidColor(VpeHandle hDoc, COLORREF color);
   void EXPO VpeSetTransparentMode(VpeHandle hDoc, int on_off);
   void EXPO VpeSetBkgMode(VpeHandle hDoc, int mode);
   void EXPO VpeSetHatchStyle(VpeHandle hDoc, int style);
   void EXPO VpeSetHatchColor(VpeHandle hDoc, COLORREF color);
   void EXPO VpeBox(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2);
   void EXPO VpeEllipse(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2);
   void EXPO VpePie(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2, int begin_angle, int end_angle);
   void EXPO VpeSetBarcodeParms(VpeHandle hDoc, int main_text, int add_text);
   void EXPO VpeSetBarcodeAlignment(VpeHandle hDoc, int alignment);
   void EXPO VpeBarcode(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2, int code_type, LPCTSTR code, LPCTSTR add_code);
   void EXPO VpeGetPictureTypes(VpeHandle hDoc, LPTSTR s, int size);
   VpeCoord EXPO VpePicture(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2, LPCTSTR file_name);
   void EXPO VpeSetFont(VpeHandle hDoc, LPCTSTR name, int size);
   void EXPO VpeSelectFont(VpeHandle hDoc, LPCTSTR name, int size);
   void EXPO VpeSetFontName(VpeHandle hDoc, LPCTSTR name);
   void EXPO VpeSetFontSize(VpeHandle hDoc, int size);
   void EXPO VpeSetCharset(VpeHandle hDoc, long charset);
   void EXPO VpeSetFontAttr(VpeHandle hDoc, int alignment, int bold, int underlined, int italic, int strikeout);
   void EXPO VpeSetTextAlignment(VpeHandle hDoc, int alignment);
   void EXPO VpeSetAlign(VpeHandle hDoc, int alignment);
   void EXPO VpeSetBold(VpeHandle hDoc, int bold);
   void EXPO VpeSetUnderlined(VpeHandle hDoc, int underlined);
   void EXPO VpeSetStrikeOut(VpeHandle hDoc, int strikeout);
   void EXPO VpeSetItalic(VpeHandle hDoc, int italic);
   void EXPO VpeSetTextColor(VpeHandle hDoc, COLORREF color);
   VpeCoord EXPO VpePrint(VpeHandle hDoc, VpeCoord x, VpeCoord y, LPCTSTR s);
   VpeCoord EXPO VpePrintBox(VpeHandle hDoc, VpeCoord x, VpeCoord y, LPCTSTR s);
   VpeCoord EXPO VpeWrite(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2, LPCTSTR s);
   VpeCoord EXPO VpeWriteBox(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2, LPCTSTR s);
   void EXPO VpeDefineHeader(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2, LPCTSTR s);
   void EXPO VpeDefineFooter(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2, LPCTSTR s);

   int  EXPO VpePageBreak(VpeHandle hDoc);
   int  EXPO VpeGetPageCount(VpeHandle hDoc);
   int  EXPO VpeGetCurrentPage(VpeHandle hDoc);
   int  EXPO VpeGotoPage(VpeHandle hDoc, int page);

   void EXPO VpeStoreSet(VpeHandle hDoc, int id);
   void EXPO VpeUseSet(VpeHandle hDoc, int id);
   void EXPO VpeRemoveSet(VpeHandle hDoc, int id);
   void EXPO VpeSetAutoBreak(VpeHandle hDoc, int mode);

   int  EXPO VpeWriteDoc(VpeHandle hDoc, LPCTSTR file_name);
   int  EXPO VpeReadDoc(VpeHandle hDoc, LPCTSTR file_name);

   void EXPO VpeSetRotation(VpeHandle hDoc, int angle);
   void EXPO VpeSetPictureCacheSize(long size);
   void EXPO VpeSetPicCacheSize(long size);
   long EXPO VpeGetPictureCacheSize();
   long EXPO VpeGetPicCacheSize();
   long EXPO VpeGetPictureCacheUsed();
   long EXPO VpeGetPicCacheUsed();
   void EXPO VpeSetPrintOffset(VpeHandle hDoc, VpeCoord offset_x, VpeCoord offset_y);
   void EXPO VpeSetPrintOffsetX(VpeHandle hDoc, VpeCoord offset_x);
   void EXPO VpeSetPrintOffsetY(VpeHandle hDoc, VpeCoord offset_y);
   VpeCoord EXPO VpeGetPrintOffsetX(VpeHandle hDoc);
   VpeCoord EXPO VpeGetPrintOffsetY(VpeHandle hDoc);
   long EXPO VpeGetLastError(VpeHandle hDoc);

   int  EXPO VpeRenderPrint(VpeHandle hDoc, VpeCoord x, VpeCoord y, LPCTSTR s);
   int  EXPO VpeRenderPrintBox(VpeHandle hDoc, VpeCoord x, VpeCoord y, LPCTSTR s);
   int  EXPO VpeRenderWrite(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2, LPCTSTR s);
   int  EXPO VpeRenderWriteBox(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2, LPCTSTR s);
   void EXPO VpeRenderPicture(VpeHandle hDoc, VpeCoord width, VpeCoord height, LPCTSTR file_name);

   long EXPO VpeGetPicturePageCount(VpeHandle hDoc, LPCTSTR file_name);
   void EXPO VpeSetPicturePage(VpeHandle hDoc, long page_no);
   long EXPO VpeGetPicturePage(VpeHandle hDoc);
   void EXPO VpeSetPictureType(VpeHandle hDoc, long picture_type);
   void EXPO VpeSetDocFileReadOnly(VpeHandle hDoc, int yes_no);
	
   int  EXPO VpeGetPenStyle(VpeHandle hDoc);
   COLORREF EXPO VpeGetPenColor(VpeHandle hDoc);
   int  EXPO VpeGetBkgMode(VpeHandle hDoc);
   COLORREF EXPO VpeGetBkgColor(VpeHandle hDoc);
   int  EXPO VpeGetHatchStyle(VpeHandle hDoc);
   COLORREF EXPO VpeGetHatchColor(VpeHandle hDoc);
   COLORREF EXPO VpeGetBkgGradientStartColor(VpeHandle hDoc);
   COLORREF EXPO VpeGetBkgGradientEndColor(VpeHandle hDoc);
   int  EXPO VpeGetBkgGradientRotation(VpeHandle hDoc);
   void EXPO VpeGetFontName(VpeHandle hDoc, LPTSTR value, UINT *size);
   int  EXPO VpeGetFontSize(VpeHandle hDoc);
   long EXPO VpeGetCharset(VpeHandle hDoc);
   int  EXPO VpeGetTextAlignment(VpeHandle hDoc);
   int  EXPO VpeGetBold(VpeHandle hDoc);
   int  EXPO VpeGetUnderlined(VpeHandle hDoc);
   int  EXPO VpeGetStrikeOut(VpeHandle hDoc);
   int  EXPO VpeGetItalic(VpeHandle hDoc);
   COLORREF EXPO VpeGetTextColor(VpeHandle hDoc);
   int  EXPO VpeGetRotation(VpeHandle hDoc);
   void EXPO VpeSetBarcodeMainTextParms(VpeHandle hDoc, int main_text);
   int  EXPO VpeGetBarcodeMainTextParms(VpeHandle hDoc);
   void EXPO VpeSetBarcodeAddTextParms(VpeHandle hDoc, int add_text);
   int  EXPO VpeGetBarcodeAddTextParms(VpeHandle hDoc);
   int  EXPO VpeGetBarcodeAlignment(VpeHandle hDoc);
   void EXPO VpeSetBarcodeAutoChecksum(VpeHandle hDoc, int yes_no);
   int  EXPO VpeGetBarcodeAutoChecksum(VpeHandle hDoc);
   void EXPO VpeSetBarcodeThinBar(VpeHandle hDoc, int n);
   int  EXPO VpeGetBarcodeThinBar(VpeHandle hDoc);
   void EXPO VpeSetBarcodeThickBar(VpeHandle hDoc, int n);
   int  EXPO VpeGetBarcodeThickBar(VpeHandle hDoc);
   long EXPO VpeGetPictureType(VpeHandle hDoc);
   int  EXPO VpeGetTransparentMode(VpeHandle hDoc);
   void EXPO VpeSetUnderline(VpeHandle hDoc, int underline);
   int  EXPO VpeGetUnderline(VpeHandle hDoc);
   int  EXPO VpeGetAutoBreak(VpeHandle hDoc);

   int  EXPO VpeGetDocExportPictureQuality(VpeHandle hDoc);
   void EXPO VpeSetDocExportPictureQuality(VpeHandle hDoc, int quality);
   
   void EXPO VpeSetDocExportType(VpeHandle hDoc, int doc_type);
   int  EXPO VpeGetDocExportType(VpeHandle hDoc);
   int  EXPO VpeGetDocExportPictureResolution(VpeHandle hDoc);
   void EXPO VpeSetDocExportPictureResolution(VpeHandle hDoc, int dpi_resolution);
   int  EXPO VpeGetFastWebView(VpeHandle hDoc);
   void EXPO VpeSetFastWebView(VpeHandle hDoc, int yes_no);
   int  EXPO VpeGetUseTempFiles(VpeHandle hDoc);
   void EXPO VpeSetUseTempFiles(VpeHandle hDoc, int yes_no);

   int  EXPO VpeGetCompression(VpeHandle hDoc);
   void EXPO VpeSetCompression(VpeHandle hDoc, int compression);
   int  EXPO VpeGetEmbedAllFonts(VpeHandle hDoc);
   void EXPO VpeSetEmbedAllFonts(VpeHandle hDoc, int yes_no);
   int  EXPO VpeGetSubsetAllFonts(VpeHandle hDoc);
   void EXPO VpeSetSubsetAllFonts(VpeHandle hDoc, int yes_no);
   void EXPO VpeSetFontControl(VpeHandle hDoc, LPCTSTR font_name, LPCTSTR subst_font_name, int do_embed, int do_subset);
   void EXPO VpeResetFontControl(VpeHandle hDoc);
   long EXPO VpeGetProtection(VpeHandle hDoc);
   void EXPO VpeSetProtection(VpeHandle hDoc, long protection_flags);
   int  EXPO VpeGetEncryption(VpeHandle hDoc);
   void EXPO VpeSetEncryption(VpeHandle hDoc, int enc_type);
   int  EXPO VpeGetEncryptionKeyLength(VpeHandle hDoc);
   void EXPO VpeSetEncryptionKeyLength(VpeHandle hDoc, int key_length);

   void EXPO VpeSetUserPassword(VpeHandle hDoc, LPCTSTR user_password);
   void EXPO VpeSetOwnerPassword(VpeHandle hDoc, LPCTSTR owner_password);
   void EXPO VpeSetAuthor(VpeHandle hDoc, LPCTSTR author);
   void EXPO VpeSetTitle(VpeHandle hDoc, LPCTSTR title);
   void EXPO VpeSetSubject(VpeHandle hDoc, LPCTSTR subject);
   void EXPO VpeSetKeywords(VpeHandle hDoc, LPCTSTR keywords);
   void EXPO VpeSetCreator(VpeHandle hDoc, LPCTSTR creator);
   void EXPO VpeEnableMultiThreading(VpeHandle hDoc, int yes_no);

   long EXPO VpeGetPDFVersion(VpeHandle hDoc);
   void EXPO VpeSetPDFVersion(VpeHandle hDoc, long version);
   void EXPO VpeSetBookmarkDestination(VpeHandle hDoc, int bkm_type, VpeCoord left, VpeCoord top, VpeCoord right, VpeCoord bottom, double zoom_factor);
   int  EXPO VpeGetBookmarkStyle(VpeHandle hDoc);
   void EXPO VpeSetBookmarkStyle(VpeHandle hDoc, int style);
   COLORREF EXPO VpeGetBookmarkColor(VpeHandle hDoc);
   void EXPO VpeSetBookmarkColor(VpeHandle hDoc, COLORREF color);
   VpeHandle EXPO VpeAddBookmark(VpeHandle hDoc, VpeHandle parent, LPCTSTR title);
   LRESULT EXPO VpeExtIntDA(VpeHandle hDoc, LPARAM i, LPARAM s);

   void EXPO VpeSetPictureCache(VpeHandle hDoc, int on_off);
   int  EXPO VpeGetPictureCache(VpeHandle hDoc);
   void EXPO VpeSetPictureX2YResolution(VpeHandle hDoc, int on_off);
   int  EXPO VpeGetPictureX2YResolution(VpeHandle hDoc);
   void EXPO VpeSetPictureBestFit(VpeHandle hDoc, int on_off);
   int  EXPO VpeGetPictureBestFit(VpeHandle hDoc);
   void EXPO VpeSetPictureEmbedInDoc(VpeHandle hDoc, int on_off);
   int  EXPO VpeGetPictureEmbedInDoc(VpeHandle hDoc);
   void EXPO VpeSetPictureDrawExact(VpeHandle hDoc, int on_off);
   int  EXPO VpeGetPictureDrawExact(VpeHandle hDoc);
   void EXPO VpeSetPictureKeepAspect(VpeHandle hDoc, int on_off);
   int  EXPO VpeGetPictureKeepAspect(VpeHandle hDoc);
   void EXPO VpeSetPictureDefaultDPI(VpeHandle hDoc, int dpix, int dpiy);

   void EXPO VpeSetCornerRadius(VpeHandle hDoc, VpeCoord radius);
   VpeCoord EXPO VpeGetCornerRadius(VpeHandle hDoc);

   void EXPO VpeSetUnitTransformation(VpeHandle hDoc, double factor);
   double EXPO VpeGetUnitTransformation(VpeHandle hDoc);
   VpeCoord EXPO VpeInternalToExternalUnit(VpeHandle hDoc, int value);
   int  EXPO VpeExternalToInternalUnit(VpeHandle hDoc, VpeCoord value);

   void EXPO VpeSetBkgGradientTriColor(VpeHandle hDoc, int on_off);
   int  EXPO VpeGetBkgGradientTriColor(VpeHandle hDoc);
   void EXPO VpeSetBkgGradientMiddleColor(VpeHandle hDoc, COLORREF color_middle);
   COLORREF EXPO VpeGetBkgGradientMiddleColor(VpeHandle hDoc);
   void EXPO VpeSetBkgGradientMiddleColorPosition(VpeHandle hDoc, int position);
   int  EXPO VpeGetBkgGradientMiddleColorPosition(VpeHandle hDoc);

   void EXPO VpeSetMsgCallback(VpeHandle hDoc, VPE_MSG_CALLBACK callback);

   void EXPO VpeSetFontSubstitution(VpeHandle hDoc, LPCTSTR original_font, LPCTSTR subst_font);
   void EXPO VpePurgeFontSubstitution(VpeHandle hDoc);

#ifdef _INC_WINDOWS // defined in windows.h
   // =======================================================================================
   //									Windows platform only
   // =======================================================================================
   HWND EXPO VpeGetWindowHandle(VpeHandle hDoc);
   HWND EXPO VpeWindowHandle(VpeHandle hDoc);

   void EXPO VpeEnablePrintSetupDialog(VpeHandle hDoc, int enabled);
   void EXPO VpeSetGridMode(VpeHandle hDoc, int in_foreground);
   void EXPO VpeSetGridVisible(VpeHandle hDoc, int yes_no);
   void EXPO VpeEnableMailButton(VpeHandle hDoc, int enabled);
   void EXPO VpeEnableCloseButton(VpeHandle hDoc, int enabled);
   void EXPO VpeEnableHelpRouting(VpeHandle hDoc, int enabled);
   void EXPO VpeSetPreviewWithScrollers(VpeHandle hDoc, int yes_no);
   void EXPO VpeSetPaperView(VpeHandle hDoc, int on_off);

   void EXPO VpeSetScale(VpeHandle hDoc, double scale);
   double EXPO VpeGetScale(VpeHandle hDoc);
   void EXPO VpeSetScalePercent(VpeHandle hDoc, int scale);
   int  EXPO VpeGetScalePercent(VpeHandle hDoc);

   void EXPO VpeSetRulersMeasure(VpeHandle hDoc, int rulers_measure);

   int  EXPO VpeSetupPrinter(VpeHandle hDoc, LPCTSTR file_name, int dialog_control);
   void EXPO VpeSetPrintOptions(VpeHandle hDoc, long flags);
   void EXPO VpePrintDoc(VpeHandle hDoc, int with_setup);
   int  EXPO VpeIsPrinting(VpeHandle hDoc);

   void EXPO VpePreviewDoc(VpeHandle hDoc, RECT *rc, int show_hide);
   void EXPO VpePreviewDocSP(VpeHandle hDoc, int x, int y, int x2, int y2, int show_hide);
   void EXPO VpeCenterPreview(VpeHandle hDoc, int width, int height, HWND parent_window);
   void EXPO VpeRefreshDoc(VpeHandle hDoc);

   VpeCoord EXPO VpePictureDIB(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2, HGLOBAL hDIB);
   VpeCoord EXPO VpePictureResID(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2, int hInstance, unsigned int res_id);
   VpeCoord EXPO VpePictureResName(VpeHandle hDoc, VpeCoord x, VpeCoord y, VpeCoord x2, VpeCoord y2, int hInstance, LPCTSTR res_name);

   void EXPO VpeSetPrintPosMode(VpeHandle hDoc, int mode);
   void EXPO VpeSetPageScrollerTracking(VpeHandle hDoc, int on_off);
   void EXPO VpeWriteStatusbar(VpeHandle hDoc, LPCTSTR text);
   void EXPO VpeOpenProgressBar(VpeHandle hDoc);
   void EXPO VpeSetProgressBar(VpeHandle hDoc, int percent);
   void EXPO VpeCloseProgressBar(VpeHandle hDoc);

   void EXPO VpeRenderPictureDIB(VpeHandle hDoc, VpeCoord width, VpeCoord height, HGLOBAL hDIB);
   void EXPO VpeRenderPictureResID(VpeHandle hDoc, VpeCoord width, VpeCoord height, int hInstance, unsigned int res_id);
   void EXPO VpeRenderPictureResName(VpeHandle hDoc, VpeCoord width, VpeCoord height, int hInstance, LPCTSTR res_name);

   int  EXPO VpeSetDevice(VpeHandle hDoc, LPCTSTR device);
   void EXPO VpeGetDevice(VpeHandle hDoc, LPTSTR device, int size);
   int  EXPO VpeDevEnum(VpeHandle hDoc);
   void EXPO VpeGetDevEntry(VpeHandle hDoc, int index, LPTSTR device, int size);
   int  EXPO VpeSetDevOrientation(VpeHandle hDoc, int orientation);
   int  EXPO VpeGetDevOrientation(VpeHandle hDoc);
   int  EXPO VpeSetDevPaperFormat(VpeHandle hDoc, int format);
   int  EXPO VpeGetDevPaperFormat(VpeHandle hDoc);
   int  EXPO VpeSetDevPaperWidth(VpeHandle hDoc, VpeCoord width);
   VpeCoord  EXPO VpeGetDevPaperWidth(VpeHandle hDoc);
   int  EXPO VpeSetDevPaperHeight(VpeHandle hDoc, VpeCoord height);
   VpeCoord  EXPO VpeGetDevPaperHeight(VpeHandle hDoc);
   int  EXPO VpeSetDevScalePercent(VpeHandle hDoc, int scale);
   int  EXPO VpeGetDevScalePercent(VpeHandle hDoc);
   int  EXPO VpeSetDevPrintQuality(VpeHandle hDoc, int quality);
   int  EXPO VpeGetDevPrintQuality(VpeHandle hDoc);
   int  EXPO VpeSetDevYResolution(VpeHandle hDoc, int yres);
   int  EXPO VpeGetDevYResolution(VpeHandle hDoc);
   int  EXPO VpeSetDevColor(VpeHandle hDoc, int color);
   int  EXPO VpeGetDevColor(VpeHandle hDoc);
   int  EXPO VpeSetDevDuplex(VpeHandle hDoc, int duplex);
   int  EXPO VpeGetDevDuplex(VpeHandle hDoc);
   int  EXPO VpeSetDevTTOption(VpeHandle hDoc, int option);
   int  EXPO VpeGetDevTTOption(VpeHandle hDoc);
   int  EXPO VpeDevEnumPaperBins(VpeHandle hDoc);
   void EXPO VpeGetDevPaperBinName(VpeHandle hDoc, int index, LPTSTR bin_name, int size);
   int  EXPO VpeGetDevPaperBinID(VpeHandle hDoc, int index);
   int  EXPO VpeSetDevPaperBin(VpeHandle hDoc, int bin_id);
   int  EXPO VpeGetDevPaperBin(VpeHandle hDoc);
   void EXPO VpeSetDevCopies(VpeHandle hDoc, int copies);
   int  EXPO VpeGetDevCopies(VpeHandle hDoc);
   void EXPO VpeSetDevCollate(VpeHandle hDoc, int collate);
   int  EXPO VpeGetDevCollate(VpeHandle hDoc);
   VpeCoord EXPO VpeGetDevPrinterOffsetX(VpeHandle hDoc);
   VpeCoord EXPO VpeGetDevPrinterOffsetY(VpeHandle hDoc);
   VpeCoord EXPO VpeGetDevPhysPageWidth(VpeHandle hDoc);
   VpeCoord EXPO VpeGetDevPhysPageHeight(VpeHandle hDoc);
   VpeCoord EXPO VpeGetDevPrintableWidth(VpeHandle hDoc);
   VpeCoord EXPO VpeGetDevPrintableHeight(VpeHandle hDoc);
   void EXPO VpeSetDevFromPage(VpeHandle hDoc, int from_page);
   int  EXPO VpeGetDevFromPage(VpeHandle hDoc);
   void EXPO VpeSetDevToPage(VpeHandle hDoc, int to_page);
   int  EXPO VpeGetDevToPage(VpeHandle hDoc);
   void EXPO VpeSetDevToFile(VpeHandle hDoc, int to_file);
   int  EXPO VpeGetDevToFile(VpeHandle hDoc);
   void EXPO VpeSetDevFileName(VpeHandle hDoc, LPCTSTR file_name);
   void EXPO VpeGetDevFileName(VpeHandle hDoc, LPTSTR file_name, int size);
   void EXPO VpeSetDevJobName(VpeHandle hDoc, LPCTSTR job_name);
   void EXPO VpeGetDevJobName(VpeHandle hDoc, LPTSTR job_name, int size);
   int  EXPO VpeDevSendData(VpeHandle hDoc, LPCTSTR data, long size);
   int  EXPO VpeReadPrinterSetup(VpeHandle hDoc, LPCTSTR file_name);
   int  EXPO VpeWritePrinterSetup(VpeHandle hDoc, LPCTSTR file_name);

   void EXPO VpeDefineKey(VpeHandle hDoc, int gui_function, int key_code, int add_key_code1, int add_key_code2);
   void EXPO VpeSendKey(VpeHandle hDoc, int vkey);
   void EXPO VpeSetGUILanguage(VpeHandle hDoc, int language);
   void EXPO VpeSetPreviewCtrl(VpeHandle hDoc, int setting);
   void EXPO VpeEnableAutoDelete(VpeHandle hDoc, int yes_no);
   void EXPO VpeClosePreview(VpeHandle hDoc);
   int  EXPO VpeIsPreviewVisible(VpeHandle hDoc);
   int  EXPO VpeGotoVisualPage(VpeHandle hDoc, int page_no);
   int  EXPO VpeGetVisualPage(VpeHandle hDoc);
   int  EXPO VpeDispatchAllMessages(VpeHandle hDoc);
   void EXPO VpeSetBusyProgressBar(VpeHandle hDoc, int visible);

   void EXPO VpeSetMailWithDialog(VpeHandle hDoc, int yes_no);
   void EXPO VpeSetMailSubject(VpeHandle hDoc, LPCTSTR subject);
   void EXPO VpeSetMailText(VpeHandle hDoc, LPCTSTR text);
   void EXPO VpeSetMailSender(VpeHandle hDoc, LPCTSTR sender);
   void EXPO VpeAddMailReceiver(VpeHandle hDoc, LPCTSTR receiver, long recip_class);
   void EXPO VpeClearMailReceivers(VpeHandle hDoc);
   void EXPO VpeAddMailAttachment(VpeHandle hDoc, LPCTSTR path, LPCTSTR file_name);
   void EXPO VpeClearMailAttachments(VpeHandle hDoc);
   void EXPO VpeSetMailAutoAttachDocType(VpeHandle hDoc, int doc_type);
   int  EXPO VpeGetMailAutoAttachDocType(VpeHandle hDoc);
   int  EXPO VpeIsMAPIInstalled(VpeHandle hDoc);
   int  EXPO VpeMailDoc(VpeHandle hDoc);

   UINT EXPO VpeMapMessage(VpeHandle hDoc, UINT message);

   void EXPO VpeSetMinScale(VpeHandle hDoc, double min_scale);
   void EXPO VpeSetMinScalePercent(VpeHandle hDoc, int min_scale_percent);
   void EXPO VpeSetMaxScale(VpeHandle hDoc, double max_scale);
   void EXPO VpeSetMaxScalePercent(VpeHandle hDoc, int max_scale_percent);

   void EXPO VpeSetResourceString(VpeHandle hDoc, int resource_id, LPCTSTR text);
   void EXPO VpeSetGUITheme(VpeHandle hDoc, int theme);
   int  EXPO VpeGetGUITheme(VpeHandle hDoc);

   void EXPO VpeSetScaleMode(VpeHandle hDoc, int mode);
   int  EXPO VpeGetScaleMode(VpeHandle hDoc);
   void EXPO VpeZoomPreview(VpeHandle hDoc, int left, int top, int right, int bottom);
   void EXPO VpeSetPreviewPosition(VpeHandle hDoc, int left, int top);
   void EXPO VpeZoomIn(VpeHandle hDoc);
   void EXPO VpeZoomOut(VpeHandle hDoc);

   int  EXPO VpeGetOpenFileName(VpeHandle hDoc, LPTSTR file_name, UINT *size);
   void EXPO VpeSetOpenFileName(VpeHandle hDoc, LPCTSTR file_name);
   int  EXPO VpeGetSaveFileName(VpeHandle hDoc, LPTSTR file_name, UINT *size);
   void EXPO VpeSetSaveFileName(VpeHandle hDoc, LPCTSTR file_name);
   void EXPO VpeOpenFileDialog(VpeHandle hDoc);
   void EXPO VpeSaveFileDialog(VpeHandle hDoc);

   void EXPO VpeSetEngineRenderMode(VpeHandle hDoc, int mode);
   int  EXPO VpeGetEngineRenderMode(VpeHandle hDoc);
#endif	// _INC_WINDOWS

//}}DLLIMPORT

#ifdef __cplusplus
}
#endif

#endif		// VPE_ACTIVEX
#endif  // _MODULE_VPIFACE
